Subject: Fatal relocation error with modssl on SPARC Solaris.

From: Rick Crist <[email-masked]>
Date: Mon, 18 Nov 2002 17:03:25 -0500

Hello All:

I am having difficulty installing a DSO version of modssl with Apache.
Configuration details are:

  o Sun Ultra 5
  o Solaris 2.6 (tried 8.0 with the same results)
  o gcc 2.95.3
  o openssl 0.9.6g
  o mm 1.2.1
  o apache 1.3.27
  o mod_ssl 2.8.12-1.3.27

OpenSSL was built as:

  $ cd ./openssl-0.9.6g
  $ sh config -fPIC
  $ make
  $ make install

The MM shared library was built as:

  $ cd ../mm-1.2.1
  $ ./configure --disable-shared
  $ make
  $ make install

Used option "b) The flexible APACI-only way" in the INSTALL document to 
apply mod_ssl to Apache:

  $ cd mod_ssl-2.8.12-1.3.27
  $ ./configure  --with-apache=../apache_1.3.27

Apache was configured with the following script:

  #!/bin/sh
  SSL_BASE=../openssl-0.9.6g \
  EAPI_MM=../mm-1.2.1 \
  CFLAGS=-fPIC \
  LIBS=/usr/lib/libC.so.5 \
  LDFLAGS='-L /usr/local/lib -R /usr/local/lib' \
  ./configure --prefix=/usr/local/apache \
              --enable-module=so \
              --enable-module=ssl \
              --enable-shared=ssl \
              --disable-rule=SSL_COMPAT \
              --enable-rule=SSL_SDBM \
              --enable-rule=EAPI

  $ make
  $ make install

After compiling and installing, I get the following error message:

  $ cd /usr/local/apache/bin
  $ ./apachectl startssl
  Syntax error on line 206 of /usr/local/apache/conf/httpd.conf: 
  Cannot load /usr/local/apache/libexec/libssl.so into server: ld.so.1: /usr/local/apache/bin/httpd: fatal: relocation error: file /usr/local/apache/libexec/libssl.so: symbol ap_mm_core_maxsegsize: referenced symbol not found
  ./apachectl startssl: httpd could not be started

This is using the stock version of httpd.conf.

The FAQ on the modssl web site indicates this is because EAPI is not applied.
However, as you can see from the configuration, it has been enabled, and the
configuration script confirms as much when run.

As for the syntax error on line 206, the offending line is:

  LoadModule ssl_module         libexec/libssl.so

If anyone can tell me what I am doing wrong, I would sure appreciate it.

Regards,

- Rick Crist
Rick Crist
Product Specialist - Test Systems
NPTest, Inc.
45 Winthrop Street, Concord, MA  01742
Phone: 978-318-4056,  Fax: 978-287-0138,  Cell: 978-764-3427
E-Mail: mailto:[email-masked]
Web: www.nptest.com

______________________________________________________________________
Apache Interface to OpenSSL (mod_ssl)                   www.modssl.org
User Support Mailing List                      [email-masked]
Automated List Manager                            [email-masked]